<?php
//////////////////////////////////////////////////////////////////////////////////
//    					 copyright (c) Arfooo Annuaire                          //
//   				 by Hocine Guillaume (c) 2007 - 2008                        //
//       					http://www.arfooo.com/                              //
//    Licence Creative Commons http://creativecommons.org/licenses/by/2.0/fr/   //
//////////////////////////////////////////////////////////////////////////////////

class SiteThumbBackgroundTask extends BackgroundTask
{
    protected $taskId = "siteThumb";
    private $httpClient;
    private $thumbsPath;

    protected function loadItems()
    {
        $c = new Criteria();
        $this->items = $this->site->findAll($c, "siteId, url", true);        
    }
    
    protected function beforeParsing()
    {
        $this->httpClient = new HttpClient();
        $this->thumbsPath = Config::get("SITES_THUMBS_PATH"); 
    }

    protected function parseItem($site)
    {
        $site->downloadAndCacheThumb(true);
        sleep(5);
    }
    
    protected function afterParsing()
    {
        Mailer::getInstance()->sendSiteThumbTaskFinished();
    }
}
        
?>