<?php
//////////////////////////////////////////////////////////////////////////////////
//    					 copyright (c) Arfooo Annuaire                          //
//   				 by Hocine Guillaume (c) 2007 - 2008                        //
//       					http://www.arfooo.com/                              //
//    Licence Creative Commons http://creativecommons.org/licenses/by/2.0/fr/   //
//////////////////////////////////////////////////////////////////////////////////

class CategoryParentModel extends Model
{   
    protected $primaryKey = "";
    
    function addNode($parentId, $childId)
    {
        //retrieve list of parent categories
        $parentCategories = $this->getParentsData($parentId);
        
        //save connections add for each parent new connection with child
        foreach($parentCategories as $category)
        {            
            $fields = array("parentId"   => $category['parentId'],
                            "categoryId" => $childId,
                            "depth"      => $category['depth'] + 1);
                            
            $newCategoryParent = new CategoryParentRecord($fields);    
            $newCategoryParent->save();
        } 
        
        //save root connection
        $fields = array("parentId"   => 0,
                        "categoryId" => $childId,
                        "depth"      => count($parentCategories) + 1);
                                                    
        $newCategoryParent = new CategoryParentRecord($fields);    
        $newCategoryParent->save();
        
        //save myself connection
        $fields = array("parentId"   => $childId,
                        "categoryId" => $childId,
                        "depth"      => 0);
                                                    
        $newCategoryParent = new CategoryParentRecord($fields);    
        $newCategoryParent->save();    
    }
    
    function getCategoriesForSelect()
    {
        $c = new Criteria();
        $c->addOrder("parentId");
        $c->addInnerJoin("categories", "categories.categoryId", "categoryparents.categoryId");
        $c->add("depth", 1);
        
        return $this->findAll($c, "categoryparents.categoryId, categoryparents.parentId, name, possibleTender", true);
    }
            
    function getParentsData($categoryId)
    {   
        $c = new Criteria();
        $c->addInnerJoin("categories", "categories.categoryId", "categoryparents.parentId");
        $c->add("categoryparents.categoryId", $categoryId);
        $c->addOrder("depth DESC");
        
        return $this->findAll($c, "name, categoryparents.parentId, depth");   
    }
    
    function getAllChildCategoriesIds($categoryId)
    {
        $c = new Criteria();
        $c->add("parentId", $categoryId);
        
        return $this->findAll($c, "categoryId");      
    }    
}

class CategoryParentRecord extends ModelRecord
{

}

?>